#include <bits/stdc++.h>
using namespace std;
int t,n,m,provera;
long long a[100005],b[100005],razl;
void unos(){
    cin >> n >> m;
    for( int i=1 ; i <=n ; i++ ){
        cin >> a[i];
    }
    for( int i=1 ; i <=m ; i++ ){
        cin >> b[i];
    }
}
void sortiranje(){
    sort( a+1 , a+1+n );
    sort( b+1 , b+1+m );
}
int main() {
cin >> t;
    while( t-- ){
        provera=0;
        unos();
        sortiranje();
        razl=a[2]-a[1];
        for( int i=n ; i>1 ; i-- ){
            long long prom=a[n]-a[n-1];
            razl=min(razl,prom);
        }
        for( int i=n ; i>1 ; i-- ){
            if( (a[i]-a[i-1])%razl!=0 ){
                cout << 0 <<endl;
                provera=1;
                break;
            }
        }
        if( provera==1 ) continue;
        for( int i=1 ; i<=m ; i++ ){
            if( b[i]-a[1]> 0 ){
                if( (b[i]-a[1])%razl==0 ) {
                    cout << 0 <<endl;
                    provera=1;
                    break;
                }
            }
        }
        if( provera==1 ) continue;
        else cout << 1 <<endl;
    }
return 0;
}